// -*- c++ -*-
//
// $Id: AalFrame.h,v 1.3 1996-02-09 10:03:30-08 bmah Exp $
//   based on:
// $ID: aalproto.h,v 1.2 1995-07-03 12:06:59-07 bmah Exp $
//
// AalFrame.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// Definitions for a simple AAL protocol.
//

#ifndef AALFRAME_H
#define AALFRAME_H

#include <stdlib.h>
#include "Pdu.h"

class AalFrame : public Pdu {

    public:

    AalFrame(Pdu *pay) : payload (pay) {
	if (payload) {
	    payload->refcount++;
	}
    }
    
    virtual ~AalFrame();

    void Detatch() {
	if (payload) {
	    payload->refcount--;
	}
	payload = NULL;
    }

    virtual ostream& Print(ostream &s);

    int vcid;			// VCID for this AAL PDU
				// (used only when sending)
    int length;			// length of AAL PDU
    Pdu *payload;		// AAL payload

};

const int AalHeaderSize = 8;	// assumed 8-byte AAL header

#endif // AALFRAME_H
