static char rcsid[] = "$Id: AppTcp.cc,v 1.5 1996-01-10 17:05:20-08 bmah Exp $";
//
// $Id: AppTcp.cc,v 1.5 1996-01-10 17:05:20-08 bmah Exp $
//
// AppTcp.cc
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// TCP application base class.  This class exists solely for the purpose
// of organizing the hierarchy of applications.
//

#include "AppTcp.h"
#include "Event.h"
#include "inline.h"

//
// AppTcp::AppTcp
//
// Input: Name, simulation pointer, start time, Tcp module name
//
// Output:  None
//
// (object constructor)
//
AppTcp::AppTcp(const String &name, Simulation *si, double initTime,
	       String &t) :
App(name, si, initTime), tcpModuleName(t) {
    tcpModule = NULL;
    Lookup(tcpModule, tcpModuleName);
}

// AppTcp::Handler
//
// (Event handler)
//
void AppTcp::Handler(Event *e)
{

    // This class doesn't have any events that it handles (at least
    // for right now) so hand off any events to the base class.
    App::Handler(e);
}

//
// AppTcp::Output
//
// Input:  None
//
// Output:  String with an ASCII representation of this object.
//
String AppTcp::Output()
{
    return name + " [AppTcp]";
}

