// -*- c++ -*-
//
// $Id: AppTcpClient.h,v 1.6 1996-06-07 09:36:26-07 bmah Exp $
//
// AppTcpClient.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef APPTCPCLIENT_H
#define APPTCPCLIENT_H

#include "AppTcp.h"

enum AppTcpClientState {
    AppTcpClientStateDown,
    AppTcpClientStateEstablishing,
    AppTcpClientStateEstablished,
    AppTcpClientStateZombie
};

class AppTcpClient : public AppTcp {

    public:

    AppTcpClient(const String &name, Simulation *si, double initTime,
		 String &t, InAddr s, short p) :
    AppTcp(name, si, initTime, t), server(s), port(p) {

	// Set our initial state
	state = AppTcpClientStateDown;

    }

    virtual ~AppTcpClient() {
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    AppTcpClientState state;	// our current FSM state
    InAddr server;		// server IP address
    short port;			// server TCP port
    TcpPcb *tp;			// TCP PCB for this connection.  We've
				// sort of optimized for clients that use
				// a single TCP connection...those that
				// need to expand on this connection
				// model can override appropriate functions.

    private:

};

#endif // APPTCPCLIENT_H
