// -*- c++ -*-
//
// $Id: AppTcpServer.h,v 1.4 1996-04-16 11:03:14-07 bmah Exp $
//
// AppTcpServer.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef APPTCPSERVER_H
#define APPTCPSERVER_H

#include "AppTcp.h"

enum AppTcpServerState {
    AppTcpServerStateDown,
    AppTcpServerStateEstablishing,
    AppTcpServerStateEstablished
};

class AppTcpServer : public AppTcp {

    public:

    AppTcpServer(const String &name, Simulation *si, double initTime,
		 String &t, short p) :
    AppTcp(name, si, initTime, t), port(p), initFlag(false) {

    }

    virtual ~AppTcpServer() {
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    bool initFlag;		// initialized yet?
    short port;			// server TCP port
    TcpPcb *tp;			// listening "socket"

    private:

};

#endif // APPTCPSERVER_H
