static char rcsid[] = "$Id";
//
// $Id: AppUdp.cc,v 1.2 1996-01-10 17:05:22-08 bmah Exp $
//   based on:
// $ID: AppTcp.cc,v 1.4 1995-12-10 14:54:11-08 bmah Exp $
//
// AppUdp.cc
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// UDP application base class.  This class exists solely for the purpose
// of organizing the hierarchy of applications.
//

#include "AppUdp.h"
#include "Event.h"
#include "inline.h"

//
// AppUdp::AppUdp
//
// Input: Name, simulation pointer, start time, Udp module name
//
// Output:  None
//
// (object constructor)
//
AppUdp::AppUdp(const String &name, Simulation *si, double initTime,
	       String &t) :
App(name, si, initTime), udpModuleName(t) {
    udpModule = NULL;
    Lookup(udpModule, udpModuleName);
}

// AppUdp::Handler
//
// (Event handler)
//
void AppUdp::Handler(Event *e)
{

    // This class doesn't have any events that it handles (at least
    // for right now) so hand off any events to the base class.
    App::Handler(e);
}

//
// AppUdp::Output
//
// Input:  None
//
// Output:  String with an ASCII representation of this object.
//
String AppUdp::Output()
{
    return name + " [AppUdp]";
}

