static char rcsid[] = "$Id: AppUdpClient.cc,v 1.1 1995-12-12 14:20:54-08 bmah Exp $";
//
// $Id: AppUdpClient.cc,v 1.1 1995-12-12 14:20:54-08 bmah Exp $
//   based on:
// $ID: AppTcpClient.cc,v 1.4 1995-12-10 14:14:41-08 bmah Exp $
//
// AppUdpClient.cc
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// TCP client application base class.  This class supports TCP applications
// that make single TCP connections to their servers.  Applications with
// more sophisticated needs can override various methods or use various
// hooks left in the class.
//

#include "AppUdpClient.h"
#include "Event.h"
#include "inline.h"

//
// AppUdpClient::Handler
//
// (Event handler)
//
void
AppUdpClient::Handler(Event *e)
{

    double time = e->ev_time;
    EventType type = e->ev_type;
    void *data = e->ev_data;

    // No real generic actions we can take, so hand the event off to the
    // parent class of TCP-using applications.
    AppUdp::Handler(e);
}

//
// AppUdpClient::Output
//
// Input:  None
//
// Output:  String with an ASCII representation of this object.
//
String
AppUdpClient::Output()
{
    return name + " [AppUdpClient]";
}



