// -*- c++ -*-
//
// $Id: AppUdpClient.h,v 1.3 1996-01-27 23:14:05-08 bmah Exp $
//   based on:
// $ID: AppTcpClient.h,v 1.2 1995-12-10 14:14:42-08 bmah Exp $
//
// AppUdpClient.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef APPUDPCLIENT_H
#define APPUDPCLIENT_H

#include "AppUdp.h"

class AppUdpClient : public AppUdp {

    public:

    AppUdpClient(const String &name, Simulation *si, double initTime,
		 String &t, InAddr s, short p) :
    AppUdp(name, si, initTime, t), server(s), port(p) {

    }

    virtual ~AppUdpClient() {
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    InAddr server;		// server IP address
    short port;			// server Udp port
    UdpPcb *tp;			// Udp PCB for this connection.  We've
				// sort of optimized for clients that use
				// a single Udp connection...those that
				// need to expand on this connection
				// model can override appropriate functions.

    private:

};

#endif // APPUDPCLIENT_H
