// -*- c++ -*-
//
// $Id: ArrivalProcess.h,v 1.2 1996-01-29 12:17:53-08 bmah Exp $
//
// ArrivalProcess.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef ARRIVALPROCESS_H
#define ARRIVALPROCESS_H

#include "ScheduledObject.h"

// Put a 10 us delay on arrival process events, in case the callback
// script tries to (indirectly) post events.
const double ArrivalProcessDelta = 0.00001;

class ArrivalProcess : public ScheduledObject {

    friend int
    ArrivalProcessObjectCmd(ClientData clientData, Tcl_Interp *interp,
			    int argc, char *argv[]);

    public:

    ArrivalProcess(const String &name, Simulation *si, double start,
		   String &s);
    virtual ~ArrivalProcess() { };

    virtual void Handler (Event *e);
    virtual String Output() = 0;

    protected:				  

    double next;		// next arrival
    String script;		// script to execute

    virtual double NextInterarrival() = 0;

};

extern int ArrivalProcessObjectCmd(ClientData clientData, Tcl_Interp *interp,
			int argc, char *argv[]);

#endif // ARRIVALPROCESS_H
