// -*- c++ -*-
//
// $Id: AudioSink.h,v 1.4 1996-03-25 18:33:48-08 bmah Exp $
//
// AudioSink.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef AUDIOSINK_H
#define AUDIOSINK_H

#include "AppUdpServer.h"
#include "Simulation.h"
#include <SmplHist.h>

class AudioSink : public AppUdpServer {

    friend int
    AudioSinkCmd(ClientData clientData, Tcl_Interp *interp,
		   int argc, char *argv[]);
    friend int
    AudioSinkObjectCmd(ClientData clientData, Tcl_Interp *interp,
			 int argc, char *argv[]);

    public:

    AudioSink(const String &name, Simulation *si, double initTime,
	      String &u, short p);
    virtual ~AudioSink();

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    double startTime;		// starting time
    double lifeTime;		// connection lifetime
    double endTime;		// ending time of this object

    int lastPacket;		// last packet received
    int packetsInSequence;
    int packetsOutOfOrder;
    int packetsGapped;
    int packets;

    SampleHistogram *delays;	// statistics structure for delay values

};

extern int AudioSinkCmd(ClientData clientData, Tcl_Interp *interp,
			  int argc, char *argv[]);
extern int AudioSinkObjectCmd(ClientData clientData, Tcl_Interp *interp,
				int argc, char *argv[]);
extern void AudioSinkDeleteProc(ClientData clientData);

#endif // AUDIOSINK_H
