// -*- c++ -*-
// $Id: Calendar.h,v 1.8 1995-11-28 23:16:52-08 bmah Exp $
//
// Calendar.h
//
// Copyright (c) 1995 The Regents of the University of California
// All Rights Reserved
// Created by Hui Zhang and Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef CALENDAR_H
#define CALENDAR_H

#include "Event.h"

const QUEUE_SIZE = 1024*6;
const HALF_MAX_DAYS = 1024*2;

class Calendar {

    //
    // Public members (were globals in original C implementation).
    //
    public:
    double clock;               // current time
    int cq_eventNum;		// number of events in calendar queue

    Calendar();
    void Insert(Event *e);
    Event *Get();
    void Sanity();

    //
    // Protected members (were static globals in original C
    // implementation).
    //
    protected:
    Event *CalendarQ[QUEUE_SIZE];
    Event **cq_bucket;
    int cq_resizeEnabled;
    int cq_lastBucket;		// bucket number last event was dequeued
    double cq_bucketTop;	// priority at the top of that bucket
    double cq_lastTime;		// priority of last dequeued event
    int cq_bottomThreshold, cq_topThreshold;
    int cq_bucketNum;		// number of buckets
    double cq_interval;		// size of intervals of each bucket
    int cq_firstSub;

    Event *NextEvent();
    void LocalInit(int qbase, int nbuck,
		   double startInterval, double lastTime);
    void Resize (int newSize);
    double NewInterval();
    void InsertEvent(Event **bucket, Event *event);
    
};

#endif // CALENDAR_H
