// -*- c++ -*-
// $Id: CellInputPort.h,v 1.6 1996-01-10 17:05:36-08 bmah Exp $
//
// CellInputPort.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef CELLINPUTPORT_H
#define CELLINPUTPORT_H

#include <iostream.h>
#include <String.h>
#include "Calendar.h"
#include "ScheduledObject.h"
#include "AtmCell.h"
#include "Tcl.h"
#include "Event.h"

class CellInputPort : public ScheduledObject {

    friend int CellInputPortCmd(ClientData clientData, Tcl_Interp *interp,
				int argc, char *argv[]);
    friend int CellInputPortObjectCmd(ClientData clientData,
				      Tcl_Interp *interp,
				      int argc, char *argv[]);
			    
    //
    // Public members
    //
    public:
    const int port;		// port number tag
    const String sink;		// name of sink object
    ScheduledObject *sinkObject;	// pointer to sink object
    const double latency;	// latency of this input port

    virtual String Output();
			     
    CellInputPort(const String &name, Simulation *si, int p, String &s,
		  double l) :
    ScheduledObject(name, si), port(p), sink(s), latency(l) {
	sinkObject = NULL;
    }

    virtual void Handler(Event *e);

};

int CellInputPortCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);
int CellInputPortObjectCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);
void CellInputPortDeleteProc(ClientData clientData);

#endif CELLINPUTPORT_H
