// -*- c++ -*-
// $Id: CellQueue.h,v 1.4 1996-01-10 17:05:37-08 bmah Exp $
//
// CellQueue.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef CELLQUEUE_H
#define CELLQUEUE_H

#include <iostream.h>
#include <String.h>
#include "Calendar.h"
#include "ScheduledObject.h"
#include "AtmCell.h"
#include "Tcl.h"

class CellQueue : public ScheduledObject {

    friend int CellQueueObjectCmd(ClientData clientData, Tcl_Interp *interp,
				  int argc, char *argv[]);

    //
    // Public members
    //
    public:
    double latency;		// latency of port and line (doesn't
				// include queueing delays
    double bitrate;		// bitrate of server
    
    String sink;		// name of sink object
    ScheduledObject *sinkObject;	// pointer to sink object

    virtual String Output();
			     
    CellQueue(const String &name, Simulation *sc) :
    ScheduledObject(name, sc) {
	sinkObject = NULL;
    }

    protected:
    String Output2();		// helper for Output method

};

int CellQueueObjectCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);

#endif // CELLQUEUE_H
