// -*- c++ -*-
// $Id: CellQueueFifo.h,v 1.5 1996-01-10 17:05:38-08 bmah Exp $
//
// CellQueueFifo.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef CELLQUEUEFIFO_H
#define CELLQUEUEFIFO_H

#include <iostream.h>
#include <String.h>
#include "Calendar.h"
#include "ScheduledObject.h"
#include "AtmCell.h"
#include "AtmCellList.h"
// #include "AtmCellPtr.DLDeque.h"
#include "Tcl.h"
#include "CellQueue.h"

class CellQueueFifo : public CellQueue {

    friend int CellQueueFifoCmd(ClientData clientData, Tcl_Interp *interp,
				int argc, char *argv[]);
    friend int CellQueueFifoObjectCmd(ClientData clientData,
				      Tcl_Interp *interp,
				      int argc, char *argv[]);
			    
    //
    // Public members
    //
    public:

    CellQueueFifo(const String &name, Simulation *si) :
    CellQueue(name, si) {
	busy = false;
    }

    ~CellQueueFifo() {
    }

    virtual String Output();
			     
    virtual void Handler(Event *e);

    protected:

    AtmCellList queue;				
    bool busy;

};

extern int CellQueueFifoCmd(ClientData clientData, Tcl_Interp *interp,
			    int argc, char *argv[]);
extern int CellQueueFifoObjectCmd(ClientData clientData, Tcl_Interp *interp,
				  int argc, char *argv[]);
void CellQueueFifoDeleteProc(ClientData clientData);

#endif // CELLQUEUEFIFO_H
