// -*- c++ -*-
// $Id: CellSink.h,v 1.4 1996-01-10 17:05:41-08 bmah Exp $
//
// CellSink.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef CELLSINK_H
#define CELLSINK_H

#include <NegExp.h>
#include "AtmCell.h"
#include "ScheduledObject.h"
#include "Simulation.h"

class CellSink : public ScheduledObject {

    friend int CellSinkObjectCmd(ClientData clientData, Tcl_Interp *interp,
				 int argc, char *argv[]);
    friend void CellSinkDeleteProc(ClientData clientData);

    public:

    CellSink(const String &name, Simulation *si) : ScheduledObject(name, si) {
    }

    virtual String Output();

    virtual void Handler(Event *e);

    protected:

};

extern int CellSinkCmd(ClientData clientData, Tcl_Interp *interp,
			 int argc, char *argv[]);
extern int CellSinkObjectCmd(ClientData clientData, Tcl_Interp *interp,
			       int argc, char *argv[]);
extern void CellSinkDeleteProc(ClientData clientData);

#endif //
