static char rcsid[] = "$Id: DeviceDriver.cc,v 1.3 1996-01-10 17:05:43-08 bmah Exp $";
//
// $Id: DeviceDriver.cc,v 1.3 1996-01-10 17:05:43-08 bmah Exp $
//
// DeviceDriver.cc
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// IP device driver parent class.
//

#include "DeviceDriver.h"
#include "inline.h"

//
// DeviceDriverObjectCmd
//
// (Tcl object command procedure)
//
int DeviceDriverObjectCmd(ClientData clientData, Tcl_Interp *interp,
			     int argc, char *argv[])
{

    DeviceDriver *dd = (DeviceDriver *) clientData;

    if (argc == 1) {
	return(ScheduledObjectCmd(clientData, interp, argc, argv));
    }

    else {

	//
	// add down object
	//
	if (!strcmp(argv[1], "down")) {
	    if (argc == 3) {
		String on;	// object name

		on = argv[2];
		dd->downName = on;
		dd->down = NULL;
		return TCL_OK;
	    }
	    else {
		Tcl_SetResult(interp, "wrong # args", TCL_STATIC);
		return(TCL_ERROR);
	    }
	}

	//
	// add up object
	//
	else if (!strcmp(argv[1], "up")) {
	    if (argc == 3) {
		String on;	// object name

		on = argv[2];
		dd->upName = on;
		dd->up = NULL;
		return TCL_OK;

	    }
	    else {
		Tcl_SetResult(interp, "wrong # args", TCL_STATIC);
		return(TCL_ERROR);
	    }
	}

	else {
	    return(ScheduledObjectCmd(clientData, interp, argc, argv));
	}
    }
}
