// -*- c++ -*-
// $Id: EmpiricalContinuous.h,v 1.1 1995-12-01 13:11:01-08 bmah Exp $
//
// EmpiricalContinuous.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// Empirical random number distribution class.
//

#ifndef EMPIRICALCONTINUOUS_H
#define EMPIRICALCONTINUOUS_H

#include "Empirical.h"

class EmpiricalContinuous : public Empirical {

public:
    EmpiricalContinuous(int num, const DoubleDistElement *dde, RNG *gen) :
    Empirical(num, dde, gen) {
    }

    //
    // EmpiricalContinuous::interpolate()
    //
    // Input:  x1, x2, y1, y2, x
    //
    // Output:  y
    //                                          (y2 - y1)
    // Compute linear interpolation of y = y1 + --------- (x - x1)
    //                                          (x2 - x1)
    virtual double interpolate(double x1, double x2,
			       double y1, double y2,
			       double x) {
	return (y1 + ((y2 - y1) / (x2 - x1)) * (x - x1));
    }

};

#endif // EMPIRICALDOUBLE_H
