// -*- c++ -*-
// $Id: EmpiricalDiscrete.h,v 1.3 1995-12-07 11:01:01-08 bmah Exp $
//
// EmpiricalDiscrete.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// Empirical random number distribution class.
//

#ifndef EMPIRICALDISCRETE_H
#define EMPIRICALDISCRETE_H

#include "Empirical.h"

class EmpiricalDiscrete : public Empirical {

public:
    EmpiricalDiscrete(int num, const DoubleDistElement *dde, RNG *gen) :
    Empirical(num, dde, gen) {
    }

    //
    // EmpiricalDiscrete::interpolate()
    //
    // Input:  x1, x2, y1, y2, x
    //
    // Output:  y
    //
    // Interpolation function for a discrete distribution is pretty
    // trivial...it's the upper data point.
    //
    virtual double interpolate(double x1, double x2, double y1, double y2,
			       double x) {

#if (defined(__ultrix__) && defined(__GNUG__))
	// Ugly ugly ugly hack to get around an apparent bug in g++-2.7.0
	// on mips-ultrix, which seems to force us to touch every parameter
	// to this function.
	//
	// Nasty bug!  We hates it, my precious, we hates it!
	return (y2 + (x2 - x2) + (x1 - x1) + (x - x) + (y1 - y1));
#else
	return (y2);
#endif
    }

};

#endif // EMPIRICALDISCRETE_H
