// -*- c++ -*-
//
// $Id: EventSink.h,v 1.4 1996-01-10 17:05:45-08 bmah Exp $
//
// EventSink.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef EVENTSINK_H
#define EVENTSINK_H

#include "ScheduledObject.h"

class EventSink : public ScheduledObject {

    friend int EventSinkCmd(ClientData clientData, Tcl_Interp *interp,
			    int argc, char *argv[]);
    friend int EventSinkObjectCmd(ClientData clientData, Tcl_Interp *interp,
				  int argc, char *argv[]);

    public:
    EventSink(const String &name, Simulation *si) :
      ScheduledObject(name, si) { }
    virtual String Output(void);
    virtual void Handler(Event *e);

};

extern int EventSinkCmd(ClientData clientData, Tcl_Interp *interp,
			int argc, char *argv[]);
extern int EventSinkObjectCmd(ClientData clientData, Tcl_Interp *interp,
			      int argc, char *argv[]);
extern void EventSinkDeleteProc(ClientData clientData);

#endif // EVENTSINK_H
