// -*- c++ -*-
//
// $Id: LanFrame.h,v 1.2 1996-02-09 10:03:35-08 bmah Exp $
//   based on:
// $ID: lanproto.h,v 1.2 1995-07-20 13:45:13-07 bmah Exp $
//
// LanFrame.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// Definitions for a shared-medium LAN datalink layer
//
#ifndef LANFRAME_H
#define LANFRAME_H

#include "Pdu.h"

class ScheduledObject;

class LanFrame : public Pdu {
    
    public:

    LanFrame(Pdu *pay) : payload(pay) {
	if (payload) {
	    payload->refcount++;
	}
    }

    virtual ~LanFrame() {
	if (payload) {
	    (payload->refcount)--;
	    if (payload->refcount == 0) {
		delete payload;
	    }
	}
    }

    void Detatch() {
	if (payload) {
	    (payload->refcount)--;
	}
	payload = NULL;
    }

    virtual ostream& Print(ostream& s);

    // Note: We use pointers to objects similar to the way a real
    // broadcast-style LAN would use datalink-layer addresses.  They
    // serve a very similar purpose, and having additional identifiers
    // for objects inside the simulator is a real lose.
    ScheduledObject *src;	// sending node
    ScheduledObject *dst;	// receiving node

    int length;		// length of LAN PDU
    Pdu *payload;		// LAN frame payload
};

const int LanHeaderSize = 16;	// assumed 16-byte AAL header

#endif // LANFRAME_H
