// -*- c++ -*-
//
// $Id: LoopbackDeviceDriver.h,v 1.5 1996-02-02 15:56:25-08 bmah Exp $
//
// LoopbackDeviceDriver.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Loopback IP device driver
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef LOOPBACKDEVICEDRIVER_H
#define LOOPBACKDEVICEDRIVER_H

#include "ScheduledObject.h"
#include "DeviceDriver.h"
#include "Tcl.h"
#include "IpPacket.h"
#include "Event.h"

class LoopbackDeviceDriver : public DeviceDriver {

    friend int
    LoopbackDeviceDriverCmd(ClientData clientData,
			    Tcl_Interp *interp,
			    int argc, char *argv[]);
    friend int
    LoopbackDeviceDriverObjectCmd(ClientData clientData,
				  Tcl_Interp *interp,
				  int argc, char *argv[]);

    public:

    const double latency;	// driver latency

    LoopbackDeviceDriver(const String &name, Simulation *si, double l) :
    DeviceDriver(name, si), latency(l) {
	expectedTime = 0.0;
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  
    double expectedTime;	// expected transmission time

};

extern int LoopbackDeviceDriverCmd(ClientData clientData, Tcl_Interp *interp,
				   int argc, char *argv[]);
extern int LoopbackDeviceDriverObjectCmd(ClientData clientData,
					 Tcl_Interp *interp,
					 int argc, char *argv[]);
extern void LoopbackDeviceDriverDeleteProc(ClientData clientData);

#endif // LOOPBACKDEVICEDRIVER_H
