// -*- c++ -*-
//
// $Id: NntpServer.h,v 1.2 1996-05-29 14:34:53-07 bmah Exp $
//   based on:
// $ID: SmtpClient.h,v 1.1.2.1 1996-04-27 14:31:02-07 bmah Exp $
//   based on:
// $ID: SampleTcpClient.h,v 1.7 1996-01-27 23:14:15-08 bmah Exp $
//
// NntpServer.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef NNTPSERVER_H
#define NNTPSERVER_H

#include "AppTcpClient.h"
#include "Simulation.h"

class NntpServer : public AppTcpClient {

    friend int
    NntpServerCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);
    friend int
    NntpServerObjectCmd(ClientData clientData, Tcl_Interp *interp,
			int argc, char *argv[]);

    public:

    NntpServer(const String &name, Simulation *si, double initTime,
	       String &t, InAddr s, short p, double g) :
    AppTcpClient(name, si, initTime, t, s, p), gap(g),
    startTime(initTime) {
    }

    virtual ~NntpServer() {
	*(sim->logStream) << name << " [NntpServer] end" <<
	  " items " << count << 
	  " sent " << totalBytesSent <<
	  " received " << totalBytesReceived <<
	  " time " << (endTime - dataStartTime) << "\n";
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    int count;			// sending count
    int remaining;		// how many left?
    int length;			// item length
    double gap;			// gap between sends

    double startTime;		// object start time
    double endTime;		// object end time
    double dataStartTime;	// data sending start time
    int totalBytesSent;
    int totalBytesReceived;

};

extern int NntpServerCmd(ClientData clientData, Tcl_Interp *interp,
			 int argc, char *argv[]);
extern int NntpServerObjectCmd(ClientData clientData, Tcl_Interp *interp,
			       int argc, char *argv[]);
extern void NntpServerDeleteProc(ClientData clientData);

#endif // NNTPSERVER_H
