// -*- c++ -*-
//
// $Id: NullDeviceDriver.h,v 1.1 1996-03-05 09:18:44-08 bmah Exp $
//   based on:
// $ID: LanDeviceDriver.h,v 1.6 1996-02-02 15:56:22-08 bmah Exp $
//
// LanDeviceDriver.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef NULLDEVICEDRIVER_H
#define NULLDEVICEDRIVER_H

#include "DeviceDriver.h"
#include "ScheduledObject.h"
#include "IpPacket.h"

class NullDeviceDriver : public DeviceDriver {

    friend int
    NullDeviceDriverCmd(ClientData clientData, Tcl_Interp *interp,
	   int argc, char *argv[]);
    friend int
    NullDeviceDriverObjectCmd(ClientData clientData, Tcl_Interp *interp,
		 int argc, char *argv[]);

    public:

    NullDeviceDriver(const String &name, Simulation *si) :
    DeviceDriver(name, si) {
    }

    ~NullDeviceDriver() {
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

};

extern int NullDeviceDriverCmd(ClientData clientData, Tcl_Interp *interp,
			       int argc, char *argv[]);
extern int NullDeviceDriverObjectCmd(ClientData clientData, Tcl_Interp *interp,
				     int argc, char *argv[]);
extern void NullDeviceDriverDeleteProc(ClientData clientData);

#endif // NULLDEVICEDRIVER_H
