static char rcsid[] = "$Id: Pdu.cc,v 1.3 1996-04-16 11:03:16-07 bmah Exp $";
//
// $Id: Pdu.cc,v 1.3 1996-04-16 11:03:16-07 bmah Exp $
//
// Pdu.cc
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#include <iostream.h>
#include "Pdu.h"

//
// Pdu::~Pdu
//
// (Object destructor)
//
// Default destructor...merely checks the refcount to ensure it's zero.
//
Pdu::~Pdu() {
    if (refcount) {
	cout << "Warning:  Pdu deleted with non-zero refcount: " <<
	  this << "\n";
    }
};

//
// Pdu::Copy
//
// Default copy operation.  Should always be overridden for classes
// where this is appropriate.
//
Pdu *Pdu::Copy()
{
    cout << "Warning:  Pdu::Copy called without being overridden for Pdu " <<
      *(this) << "\n";
}

//
// Printing methods
//
ostream& Pdu::Print(ostream &s) {
    return s << "([Pdu] refcount " << refcount << ")";
}

ostream& operator<<(ostream &s, Pdu &pdu)
{
    return pdu.Print(s);
}

ostream& operator<<(ostream &s, Pdu *pdu)
{
    return pdu->Print(s);
}

