// -*- c++ -*-
//
// $Id: PeriodicProcess.h,v 1.1 1996-01-27 16:44:04-08 bmah Exp $
//
// PeriodicProcess.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef PERIODICPROCESS_H
#define PERIODICPROCESS_H

#include "ArrivalProcess.h"

class PeriodicProcess : public ArrivalProcess {

    friend int
    PeriodicProcessCmd(ClientData clientData, Tcl_Interp *interp,
	   int argc, char *argv[]);
    friend int
    PeriodicProcessObjectCmd(ClientData clientData, Tcl_Interp *interp,
		 int argc, char *argv[]);

    public:

    PeriodicProcess(const String &name, Simulation *si, double start,
		   double l, String &s);

    virtual String Output(void);

    protected:				  

    const double period;		// constant interarrival time

    virtual double NextInterarrival();

};

extern int PeriodicProcessCmd(ClientData clientData, Tcl_Interp *interp,
			     int argc, char *argv[]);
extern int PeriodicProcessObjectCmd(ClientData clientData, Tcl_Interp *interp,
				   int argc, char *argv[]);
extern void PeriodicProcessDeleteProc(ClientData clientData);

#endif // PERIODICPROCESS_H
