// -*- c++ -*-
//
// $Id: PoissonProcess.h,v 1.1 1996-01-27 16:44:06-08 bmah Exp $
//
// PoissonProcess.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef POISSONPROCESS_H
#define POISSONPROCESS_H

#include <NegExp.h>
#include "ArrivalProcess.h"

class PoissonProcess : public ArrivalProcess {

    friend int
    PoissonProcessCmd(ClientData clientData, Tcl_Interp *interp,
	   int argc, char *argv[]);
    friend int
    PoissonProcessObjectCmd(ClientData clientData, Tcl_Interp *interp,
		 int argc, char *argv[]);

    public:

    PoissonProcess(const String &name, Simulation *si, double start,
		   double l, String &s);

    virtual String Output(void);

    protected:				  

    double lambda;		// average for distribution
    NegativeExpntl *distrib;	// negative exponential random distribution

    virtual double NextInterarrival();

};

extern int PoissonProcessCmd(ClientData clientData, Tcl_Interp *interp,
			     int argc, char *argv[]);
extern int PoissonProcessObjectCmd(ClientData clientData, Tcl_Interp *interp,
				   int argc, char *argv[]);
extern void PoissonProcessDeleteProc(ClientData clientData);

#endif // POISSONPROCESS_H
