// -*- c++ -*-
//
// $Id: SampleTcpClient.h,v 1.7 1996-01-27 23:14:15-08 bmah Exp $
//
// SampleTcpClient.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef SAMPLETCPCLIENT_H
#define SAMPLETCPCLIENT_H

#include "AppTcpClient.h"
#include "Simulation.h"

class SampleTcpClient : public AppTcpClient {

    friend int
    SampleTcpClientCmd(ClientData clientData, Tcl_Interp *interp,
	   int argc, char *argv[]);
    friend int
    SampleTcpClientObjectCmd(ClientData clientData, Tcl_Interp *interp,
		 int argc, char *argv[]);

    public:

    SampleTcpClient(const String &name, Simulation *si, double initTime,
		    String &t, InAddr s, short p, int l, int c, double g) :
    AppTcpClient(name, si, initTime, t, s, p), length(l), count(c), gap(g) {
	startTime = initTime;
    }

    virtual ~SampleTcpClient() {
	*(sim->logStream) << name << " [SampleTcpClient] end send " <<
	  totalBytesSent << " received " << totalBytesReceived <<
	    " time " << (endTime - dataStartTime) << "\n";
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    int length;			// sending length
    int count;			// sending count
    double gap;			// gap between sends

    double startTime;		// object start time
    double endTime;		// object end time
    double dataStartTime;	// data sending start time
    int totalBytesSent;
    int totalBytesReceived;

};

extern int SampleTcpClientCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);
extern int SampleTcpClientObjectCmd(ClientData clientData, Tcl_Interp *interp,
			int argc, char *argv[]);
extern void SampleTcpClientDeleteProc(ClientData clientData);

#endif // SAMPLETCPCLIENT_H
