// -*- c++ -*-
//
// $Id: SampleTcpServer.h,v 1.4 1996-01-10 17:05:59-08 bmah Exp $
//
// SampleTcpServer.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef SAMPLETCPSERVER_H
#define SAMPLETCPSERVER_H

#include "AppTcpServer.h"

// Per-connection bookkeeping state
typedef struct SampleTcpServerConnection {
    TcpPcb *tcp;		// pointer to connection
    double startTime;		// start time
    int totalBytesSent;
    int totalBytesReceived;
    SampleTcpServerConnection *next; // SLL pointer
};

class SampleTcpServer : public AppTcpServer {

    friend int
    SampleTcpServerCmd(ClientData clientData, Tcl_Interp *interp,
	   int argc, char *argv[]);
    friend int
    SampleTcpServerObjectCmd(ClientData clientData, Tcl_Interp *interp,
		 int argc, char *argv[]);

    public:

    SampleTcpServer(const String &name, Simulation *si, double initTime,
		    String &t, short p) :
    AppTcpServer(name, si, initTime, t, p) {
	active = NULL;
    }

    virtual ~SampleTcpServer() {
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    SampleTcpServerConnection *active;

    private:

};

extern int SampleTcpServerCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);
extern int SampleTcpServerObjectCmd(ClientData clientData, Tcl_Interp *interp,
			int argc, char *argv[]);
extern void SampleTcpServerDeleteProc(ClientData clientData);

#endif // SAMPLETCPSERVER_H
