// -*- c++ -*-
// $Id: Simulation.h,v 1.7 1996-01-31 10:52:30-08 bmah Exp $
//
// Simulation.h
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef SIMULATION_H
#define SIMULATION_H

#include <iostream.h>
#include <String.h>
#include <ACG.h>
#include "Calendar.h"
#include "ScheduledObject.h"
#include "Tcl.h"

class Simulation: public ScheduledObject {

    friend void Initialize(void);

    //
    // Public members
    //
    public:
    bool run;
    bool trace;
    bool interactive;
    bool stayInCli;
    
    Simulation(const String &name);

    virtual void Handler(Event *e);
    virtual String Output();

    ostream *debugStream;	// stream for debugging output
    ostream *logStream;		// stream for logging output

    //
    // Protected members
    //
    Calendar *scheduler;
    ACG *rng;

};

int SimulationCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);

#endif // SIMULATION_H
