// -*- c++ -*-
//
// $Id: SmtpClient.h,v 1.2 1996-05-29 14:35:05-07 bmah Exp $
//   based on:
// $ID: SampleTcpClient.h,v 1.7 1996-01-27 23:14:15-08 bmah Exp $
//
// SmtpClient.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef SMTPCLIENT_H
#define SMTPCLIENT_H

#include "AppTcpClient.h"
#include "Simulation.h"

class SmtpClient : public AppTcpClient {

    friend int
    SmtpClientCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);
    friend int
    SmtpClientObjectCmd(ClientData clientData, Tcl_Interp *interp,
			int argc, char *argv[]);

    public:

    SmtpClient(const String &name, Simulation *si, double initTime,
	       String &t, InAddr s, short p, double g) :
    AppTcpClient(name, si, initTime, t, s, p), count(1), gap(g),
    startTime(initTime) {
    }

    virtual ~SmtpClient() {
	*(sim->logStream) << name << " [SmtpClient] end send " <<
	  totalBytesSent << " received " << totalBytesReceived <<
	    " time " << (endTime - dataStartTime) << "\n";
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    int count;			// sending count
    int length;			// item length
    double gap;			// gap between sends

    double startTime;		// object start time
    double endTime;		// object end time
    double dataStartTime;	// data sending start time
    int totalBytesSent;
    int totalBytesReceived;

};

extern int SmtpClientCmd(ClientData clientData, Tcl_Interp *interp,
			 int argc, char *argv[]);
extern int SmtpClientObjectCmd(ClientData clientData, Tcl_Interp *interp,
			       int argc, char *argv[]);
extern void SmtpClientDeleteProc(ClientData clientData);

#endif // SMTPCLIENT_H
