// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _StringScheduledObjectPtrCHMap_h
#ifdef __GNUG__
#pragma interface
#endif
#define _StringScheduledObjectPtrCHMap_h 1

#include "String.ScheduledObjectPtr.Map.h"

#ifndef _StringScheduledObjectPtrCHNode_h
#define _StringScheduledObjectPtrCHNode_h 1

struct StringScheduledObjectPtrCHNode
{
  StringScheduledObjectPtrCHNode*      tl;
  String                hd;
  ScheduledObjectPtr                cont;
                     StringScheduledObjectPtrCHNode();
                     StringScheduledObjectPtrCHNode(String& h, ScheduledObjectPtr  c, StringScheduledObjectPtrCHNode* t = 0);
                     ~StringScheduledObjectPtrCHNode();
};

inline StringScheduledObjectPtrCHNode::StringScheduledObjectPtrCHNode() {}

inline StringScheduledObjectPtrCHNode::StringScheduledObjectPtrCHNode(String& h, ScheduledObjectPtr  c, StringScheduledObjectPtrCHNode* t)
     : hd(h), cont(c), tl(t) {}

inline StringScheduledObjectPtrCHNode::~StringScheduledObjectPtrCHNode() {}

typedef StringScheduledObjectPtrCHNode* StringScheduledObjectPtrCHNodePtr;

#endif


class StringScheduledObjectPtrCHMap : public StringScheduledObjectPtrMap
{
protected:
  StringScheduledObjectPtrCHNode** tab;
  unsigned int   size;

public:
                StringScheduledObjectPtrCHMap(ScheduledObjectPtr  dflt,unsigned int sz=DEFAULT_INITIAL_CAPACITY);
                StringScheduledObjectPtrCHMap(StringScheduledObjectPtrCHMap& a);
                ~StringScheduledObjectPtrCHMap();

  ScheduledObjectPtr&          operator [] (const String& key);

  void          del(String& key);

  Pix           first();
  void          next(Pix& i);
  String&          key(Pix i);
  ScheduledObjectPtr&          contents(Pix i);

  Pix           seek(String& key);
  int           contains(String& key);

  void          clear(); 
  int           OK();
};


inline StringScheduledObjectPtrCHMap::~StringScheduledObjectPtrCHMap()
{
  clear();
  delete tab;
}

inline int StringScheduledObjectPtrCHMap::contains(String& key)
{
  return seek(key) != 0;
}

inline String& StringScheduledObjectPtrCHMap::key(Pix p)
{
  if (p == 0) error("null Pix");
  return ((StringScheduledObjectPtrCHNode*)p)->hd;
}

inline ScheduledObjectPtr& StringScheduledObjectPtrCHMap::contents(Pix p)
{
  if (p == 0) error("null Pix");
  return ((StringScheduledObjectPtrCHNode*)p)->cont;
}

#endif
