static char rcsid[] = "$Id: Tcl.cc,v 1.5 1996-01-29 00:42:45-08 bmah Exp $";
//
// $Id: Tcl.cc,v 1.5 1996-01-29 00:42:45-08 bmah Exp $
// 
// Tcl.cc
//
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// Tcl C++ wrappers and glue.
//
#include "Tcl.h"

int Tcl::Init(void) {
    int rc = Tcl_Init(tclInterp);
    result = tclInterp->result;
    return rc;
}

char *Tcl::SetVar(const String &varName, double newValue, int flags) {
    char tempChars[80];
    sprintf(tempChars, "%f", newValue);

    char *rc = Tcl_SetVar(tclInterp, (const char *) varName, tempChars, flags);
    return rc;
}

char *Tcl::SetVar(const String &varName, int newValue, int flags) {
    char tempChars[80];
    sprintf(tempChars, "%d", newValue);

    char *rc = Tcl_SetVar(tclInterp, (const char *) varName, tempChars, flags);
    return rc;
}

char *Tcl::SetVar(const String &varName, const String &newValue, int flags) {

    char *rc = Tcl_SetVar(tclInterp, (const char *) varName,
			  (const char *) newValue,
			  flags);
    return rc;
}

char *Tcl::GetVar(const String &varName, int flags) {

    return Tcl_GetVar(tclInterp, (const char *) varName, flags);

}

int Tcl::Eval(const String &script) {
    int rc = Tcl_Eval(tclInterp, (const char *) script);
    result = tclInterp->result;
    return rc;
}

int Tcl::Eval(const char *script) {
    int rc = Tcl_Eval(tclInterp, (const char *) script);
    result = tclInterp->result;
    return rc;
}

int Tcl::EvalFile(const String &fileName) {
    int rc = Tcl_EvalFile(tclInterp, (const char *) fileName);
    result = tclInterp->result;
    return rc;
}

int Tcl::RecordAndEval(const String &script, int flags) {
    int rc = Tcl_RecordAndEval(tclInterp, (const char *) script, flags);
    result = tclInterp->result;
    return rc;
}

void Tcl::AddErrorInfo(const String &data) {
    Tcl_AddErrorInfo(tclInterp, (const char *) data);
}

void Tcl::CreateCommand(const String &cmdName, Tcl_CmdProc *cmdProc,
			ClientData clientData, Tcl_CmdDeleteProc *deleteProc) {
    Tcl_CreateCommand(tclInterp, (const char *) cmdName, cmdProc,
		      clientData, deleteProc);
}

