// -*- c++ -*-
//
// $Id: Tcl.h,v 1.7 1996-01-29 00:42:46-08 bmah Exp $
//
// Tcl.h
//
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
#ifndef TCL_H
#define TCL_H

#include "String.h"
extern "C" {
#include "tcl.h"
}

class Tcl {

    // public members
    public:
    String result;

    Tcl() { tclInterp = Tcl_CreateInterp(); }
    ~Tcl() { Tcl_DeleteInterp(tclInterp); }
    
    int Init(void);

    char *SetVar(const String &varName, double newValue, int flags);
    char *SetVar(const String &varName, int newValue, int flags);
    char *SetVar(const String &varName, const String &newValue, int flags);
    char *GetVar (const String &varName, int flags);

    int Eval(const String &script);
    int Eval(const char *script);
    int EvalFile(const String &fileName);
    int RecordAndEval(const String &script, int flags);

    void AddErrorInfo(const String &data);

    void CreateCommand(const String &cmdName, Tcl_CmdProc *cmdProc,
		       ClientData clientData, Tcl_CmdDeleteProc *deleteProc);

    // protected members
    protected:
    Tcl_Interp *tclInterp;

};

#endif // TCL_H
