// -*- c++ -*-
// $Id: TcpData.h,v 1.2 1996-02-02 15:56:36-08 bmah Exp $
//
// TcpData.h
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// Definitions for a struct/object of TCP data segments (roughly
// analogous to mbufs).
//

#ifndef TCPDATA_H
#define TCPDATA_H

#include "TcpSegment.h"

typedef struct TcpData {
    TcpSeq seq;			// sequence number.  This data element
				// doesn't get delivered to the application
				// until octet seq is.
    union {
	void *data_ptr;		// two types of data...pointer to another
				// data struct (owned by the receiving
				// process)
	int data_int;		// or an int.
    };
    TcpData *next;		// SLL next pointer
};

#endif // TCPDATA_H
