static char rcsid[] = "$Id: TcpSegment.cc,v 1.1 1996-02-06 16:51:53-08 bmah Exp $";
//
// $Id: TcpSegment.cc,v 1.1 1996-02-06 16:51:53-08 bmah Exp $
//
// TcpSegment.cc
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//


#include "TcpSegment.h"
#include "Tcp.h"

//
// TcpSegment::Print
//
// Input:  output stream s
//
// Output:  output stream (in return value)
//
// Print TCP header
//
ostream& TcpSegment::Print(ostream &s)
{
    s << "([TcpSegment] sport " << th_sport << " dport " << th_dport << " seq " << th_seq << " ack " << th_ack << " th_flags { ";
    if (th_flags & TH_FIN) {
	s << "FIN ";
    }
    if (th_flags & TH_SYN) {
	s << "SYN ";
    }
    if (th_flags & TH_RST) {
	s << "RST ";
    }
    if (th_flags & TH_PUSH) {
	s << "PUSH ";
    }
    if (th_flags & TH_ACK) {
	s << "ACK ";
    }
    if (th_flags & TH_URG) {
	s << "URG ";
    }
    s << "} refcout " << refcount << ")";
    return s;
}
