// -*- c++ -*-
//
// $Id: TcpSegment.h,v 1.2 1996-02-06 16:51:54-08 bmah Exp $
//   based on:
// $ID: tcpproto.h,v 1.4 1996-01-16 10:38:42-08 bmah Exp $
//
// tcpproto.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// TCP packet definitions
//

#ifndef TCPSEGMENT_H
#define TCPSEGMENT_H

//
// We need definitions from ipproto.h first, as they include the glue
// to make other BSD 4.4Lite-derived definitions work.
//
#include "IpPacket.h"

//
// TCP sequence number space
//
typedef u_long TcpSeq;

#include "TcpData.h"
#include "TcpDataList.h"

//
// See IpPacket.h for some comments on the INSANE definitions of
// various IP-related structures.
//
class TcpSegment : public Pdu {

    public:

    TcpSegment() {
    }

    virtual ~TcpSegment() {
    }

    virtual ostream& Print(ostream &s);

    u_short	th_sport;	// source port
    u_short 	th_dport;	// destination port
    TcpSeq	th_seq;		// sequence number
    TcpSeq	th_ack;		// acknowledgement number

    u_char 	th_flags;	// Flags: ACK, FIN, PUSH, RST, SYN, URG
    u_short	th_win;		// advertised window

    TcpDataList payload;	// packet payload, if any

};

const int TcpHeaderSize = 20;
const int TcpMinEphemeralPort = 1024;
const int TcpMaxEphemeralPort = 32768;

#endif // TCPSEGMENT_H
