// -*- c++ -*-
//
// $Id: TelnetServer.h,v 1.3 1996-01-10 17:06:14-08 bmah Exp $
//   based on:
// $ID: SampleTcpServer.h,v 1.2 1995-10-09 10:37:29-07 bmah Exp $
//
// TelnetServer.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef TELNETSERVER_H
#define TELNETSERVER_H

#include "AppTcpServer.h"

//
// Global constants
//
const double TelnetServerLatency = 0.001; // telnet server latency 1 ms

// Per-connection bookkeeping state
typedef struct TelnetServerConnection {
    TcpPcb *tcp;		// pointer to connection
    double startTime;		// start time
    int totalBytesSent;
    int totalBytesReceived;
    TelnetServerConnection *next; // SLL pointer
};

class TelnetServer : public AppTcpServer {

    friend int
    TelnetServerCmd(ClientData clientData, Tcl_Interp *interp,
	   int argc, char *argv[]);
    friend int
    TelnetServerObjectCmd(ClientData clientData, Tcl_Interp *interp,
		 int argc, char *argv[]);

    public:

    TelnetServer(const String &name, Simulation *si, double initTime,
		 String &t, short p) :
    AppTcpServer(name, si, initTime, t, p) {
	active = NULL;
    }

    virtual ~TelnetServer() {
    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    TelnetServerConnection *active;

    private:

};

extern int TelnetServerCmd(ClientData clientData, Tcl_Interp *interp,
		  int argc, char *argv[]);
extern int TelnetServerObjectCmd(ClientData clientData, Tcl_Interp *interp,
			int argc, char *argv[]);
extern void TelnetServerDeleteProc(ClientData clientData);

#endif // TELNETSERVER_H
