// -*- c++ -*-
// $Id: UdpData.h,v 1.3 1996-02-02 15:56:39-08 bmah Exp $
//   based on:
// $ID: TcpData.h,v 1.1 1995-10-19 14:22:47-07 bmah Exp $
//
// UdpData.h
//
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// Definitions for a struct/object of UDP data segments (roughly
// analogous to mbufs).
//

#ifndef UDPDATA_H
#define UDPDATA_H

#include "UdpPacket.h"

typedef struct UdpData {
    union {
	void *data_ptr;		// three types of data...pointer to another
				// data struct (owned by the receiving
				// process)
	int data_int;		// ...or an int...
	double data_time;	// ...or a timestamp
    };
    int seq;			// sequence number of this datagram
    UdpData *next;		// SLL next pointer
};

#endif // UDPDATA_H
