// -*- c++ -*-
//
// $Id: UdpPacket.h,v 1.2 1996-02-06 16:51:56-08 bmah Exp $
//   based on:
// $ID: udpproto.h,v 1.4 1996-01-22 13:33:30-08 bmah Exp $
//
// UdpPacket.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//
// UDP packet definitions
//

#ifndef UDPPACKET_H
#define UDPPACKET_H

#include <iostream.h>

//
// We need definitions from ipproto.h first, as they include the glue
// to make other BSD 4.4Lite-derived definitions work.
//
#include "IpPacket.h"
#include "Pdu.h"
#include "UdpDataList.h"

//
// #include "netinet/udp.h"
//

//
// UDP payload types (see declaration of UdpMessage->type below).
//
enum UdpPayloadType {
    UdpPayloadTypeNull,
    UdpPayloadTypeAudio,
    UdpPayloadTypeVideo
};

//
// See ipproto.h for some comments on the INSANE definitions of
// various IP-related structures.
//
class UdpPacket : public Pdu {

    public:

    UdpPacket() {
    }

    virtual ~UdpPacket() {
    }

    virtual ostream& Print(ostream &s);

    u_short	uh_sport;	// source port
    u_short 	uh_dport;	// destination port
    short 	uh_ulen;	// udp length

    UdpPayloadType type;	// payload type.  This field is a bit
				// of a fantasy, as UDP is pretty
				// ignorant of its packet payloads.
				// It's intended to simulate the RTP
				// packet payload type field.

    UdpDataList payload;	// packet payload, if any
};

const int UdpHeaderSize = 8;

#endif // UDPPACKET_H
