// -*- c++ -*-
//
// $Id: VideoSink.h,v 1.2 1996-03-25 18:33:53-08 bmah Exp $
//   based on:
// $ID: AudioSink.h,v 1.3 1996-01-22 11:14:55-08 bmah Exp $
//
// VideoSink.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef VIDEOSINK_H
#define VIDEOSINK_H

#include "AppUdpServer.h"
#include "Simulation.h"
#include <SmplHist.h>

class VideoSink : public AppUdpServer {

    friend int
    VideoSinkCmd(ClientData clientData, Tcl_Interp *interp,
		   int argc, char *argv[]);
    friend int
    VideoSinkObjectCmd(ClientData clientData, Tcl_Interp *interp,
			 int argc, char *argv[]);

    public:

    VideoSink(const String &name, Simulation *si, double initTime,
	      String &u, short p);
    virtual ~VideoSink();

    virtual String Output(void);
    virtual void Handler(Event *e);

    protected:				  

    double startTime;		// starting time
    double lifeTime;		// connection lifetime
    double endTime;		// ending time of this object

    int lastPacket;		// last packet received
    int packetsInSequence;
    int packetsOutOfOrder;
    int packetsGapped;
    int packets;

    SampleHistogram *delays;	// statistics structure for delay values

};

extern int VideoSinkCmd(ClientData clientData, Tcl_Interp *interp,
			  int argc, char *argv[]);
extern int VideoSinkObjectCmd(ClientData clientData, Tcl_Interp *interp,
				int argc, char *argv[]);
extern void VideoSinkDeleteProc(ClientData clientData);

#endif // VIDEOSINK_H
