// -*- c++ -*-
//
// $Id: VideoSource.h,v 1.2 1996-01-27 23:14:20-08 bmah Exp $
//   based on:
// $ID: AudioSource.h,v 1.2 1996-01-10 17:05:33-08 bmah Exp $
//
// VideoSource.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef VIDEOSOURCE_H
#define VIDEOSOURCE_H

#include "AppUdpClient.h"
#include "Simulation.h"

class VideoSource : public AppUdpClient {

    friend int
    VideoSourceCmd(ClientData clientData, Tcl_Interp *interp,
		   int argc, char *argv[]);
    friend int
    VideoSourceObjectCmd(ClientData clientData, Tcl_Interp *interp,
			 int argc, char *argv[]);

    public:

    VideoSource(const String &name, Simulation *si, double initTime,
		String &u, InAddr s, short p, int pay, double g);

    virtual
    ~VideoSource()
    {
	*(sim->logStream) << name << " [VideoSource] lifetime " << lifeTime << " packets " << packetsSent << "\n";

    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    const double gap;		// sending gap
    const int payloadBytes;	// number of UDP payload bytes

    protected:				  

    double startTime;		// starting time
    double lifeTime;		// connection lifetime
    double endTime;		// ending time of this object
    int packetsSent;		// number of packets sent

};

extern int VideoSourceCmd(ClientData clientData, Tcl_Interp *interp,
			  int argc, char *argv[]);
extern int VideoSourceObjectCmd(ClientData clientData, Tcl_Interp *interp,
				int argc, char *argv[]);
extern void VideoSourceDeleteProc(ClientData clientData);

#endif // VIDEOSOURCE_H
