// -*- c++ -*-
//
// $Id: VideoSource2.h,v 1.1 1996-03-04 13:59:52-08 bmah Exp $
//   based on:
// $Id: VideoSource2.h,v 1.1 1996-03-04 13:59:52-08 bmah Exp $
//   based on:
// $ID: AudioSource.h,v 1.2 1996-01-10 17:05:33-08 bmah Exp $
//
// VideoSource2.h
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
//
// Copyright (c) 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#ifndef VIDEOSOURCE2_H
#define VIDEOSOURCE2_H

#include "AppUdpClient.h"
#include "Simulation.h"

enum VideoSource2State {
    VideoSource2StateCr,
    VideoSource2StateBg,
};

class VideoSource2 : public AppUdpClient {

    friend int
    VideoSource2Cmd(ClientData clientData, Tcl_Interp *interp,
		    int argc, char *argv[]);
    friend int
    VideoSource2ObjectCmd(ClientData clientData, Tcl_Interp *interp,
			  int argc, char *argv[]);

    public:

    VideoSource2(const String &name, Simulation *si, double initTime,
		 String &u, InAddr s, short p, double br, double f);

    virtual
    ~VideoSource2()
    {
	*(sim->logStream) << name << " [VideoSource2] lifetime " << lifeTime << " packets " << packetsSent << "\n";

    }

    virtual String Output(void);
    virtual void Handler(Event *e);

    const double bitrate;	// sending bitrate
    const double fps;		// number of frames per second

    protected:				  

    VideoSource2State state;	// current sending mode
    int packetsThisState;	// number of packets to send in current state
    double startTime;		// starting time
    double lifeTime;		// connection lifetime
    double endTime;		// ending time of this object
    int packetsSent;		// number of packets sent

};

extern int VideoSource2Cmd(ClientData clientData, Tcl_Interp *interp,
			   int argc, char *argv[]);
extern int VideoSource2ObjectCmd(ClientData clientData, Tcl_Interp *interp,
				 int argc, char *argv[]);
extern void VideoSource2DeleteProc(ClientData clientData);

#endif // VIDEOSOURCE2_H
