status char rcsid[] = "$Id$";
//
// $Id$
//
// status.cc
// Bruce A. Mah (bmah@CS.Berkeley.EDU)
// 
// Copyright (c) 1995, 1996 The Regents of the University of California
// All Rights Reserved
// Created by Bruce A. Mah
// Department of Electrical Engineering and Computer Sciences,
//   Computer Science Division
//

#include <time.h>
#include <stdio.h>
#include <fstream.h>
#include <iostream.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/param.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>

#include "util.h"
#include "Calendar.h"
#include "ScheduledObject.h"
#include "user.h"

static int Sock;		// socket number
static struct sockaddr_in Addr;	// socket address of monitoring process

//
// StatusHostName
//
int StatusHostname(char *hostspec) {

    String arg, hostArg, portArg; // parsed arguments from cmdline
    struct hostent *host;	      // host

    // Parse host/port arg
    arg = (String) hostspec;
    hostArg = arg.before("/");
    portArg = arg.after("/");

    // Do a nameserver lookup to get the monitoring host
    port = atoi((const char *) portArg);
    host = gethostbyname((const char *) hostArg);
    if (host == NULL) {
	endhostent();
	perror("gethostbyname");
	return(-1);
    }

    // Fill in the addr structure so we can send data
    bzero((char *) &Addr, sizeof(Addr));
    Addr.sin_family = AF_INET;
    bcopy((const char *) host->h_addr, (char *) &Addr.sin_addr,
	  host->h_length);
    Addr.sin_port = htons(port);

    return (0);

}

//
// StatusInit
//
int StatusInit()
{

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if (sock < 0) {
	perror("socket");
	exit(1);
    }

}

//
// StatusUpdate
//
void StatusUpdate((const char *) cmd,
		  int start, int now, int events, double simtime)
{

    extern char HostName[];
    extern int Pid;

    // Compose a status report and send it.
    sprintf(StatBuffer,
	    "system insane host %s pid %d hosttype %s args {%s} status running start %d time %d events %d simtime %f",
	    HostName, Pid, HOST_TYPE,
	    cmd,
	    start, now, events, simtime);
    sendto(sock, StatBuffer, strlen(StatBuffer) + 1, 0,
	   (sockaddr *) &Addr, sizeof(Addr));

}
